// ●リスト6::for文でletを使う
// ES5
// (d1)ES5でよくある間違い
for (var i = 0; i < 5; i++) {
  setTimeout(function() {console.log(i)}, i * 100);
}
// "5"が5回表示されてしまう

// (d2)ES5で正しく動作するコード
for (var i = 0; i < 5; i++) {
  (function(x) {
    // iを関数スコープにxとして保存する
    setTimeout(function() {console.log(x)}, x * 100);
  })(i);
}

// ES6
// (d3)iをletで宣言
for (let i = 0; i < 5; i++) {
  // iは各ループ（ブロックスコープ）ごとに保存される
  setTimeout(function() {console.log(i)}, i * 100);
}
