// ●リスト9::タグ付きテンプレート
var name = "Bob <script>";
// (d1)タグ付きテンプレート
el.innerHTML = html`<p>Hello, ${name}</p>`;

// (d2)タグ関数
function html(templates, ...values) {
  // templates: ["<p>Hello, ", "${name}</p>"]
  // values: ["Bob <script>"]
  var result = "";
  for (let i = 0; i < templates.length; i++){
    result += templates[i];
    if (i < values.length){
      // (d3)変数をHTMLエスケープ
      result += escapeHtml(values[i]);
    }
  }
  return result
  // <p>Hello, Bob &lt;script&gt;</p>
}

// HTMLエスケープ関数
function escapeHtml(str) {
  return str.replace(/&/g, '').
    replace(/&/g, '&amp;').
    replace(/</g, '&lt;').
    replace(/>/g, '&gt;').
    replace(/"/g, '&quot;').
    replace(/'/g, '&#039;');
}
