// ●リスト2::Promiseによる非同期処理
function getFirstItem() {
  return getUrl("/items").then(items => {
    return getUrl("/items/" + items[0].id);
  });
}

// 本体側からの呼び出し
getFirstItem().then(item => {
  someProcess(item);
}).catch(e => {
  // エラー処理
  console.error(e);
})

function getUrl(url) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = () => {
      if (xhr.status === 200) {
        resolve(xhr.statusText);
      } else {
        // (d1)エラーの場合rejectを呼ぶ
        reject(new Error(xhr.statusText));
      }
    };
    xhr.onerror = () => {
      // (d2)エラーの場合rejectを呼ぶ
      reject(new Error(xhr.statusText));
    };
    xhr.send();
  });
}
