// ●リスト5::Promiseの基本
function wait(time) {
  // (d1)Promiseオブジェクトの生成
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      // (d2)resolveすると最初のthenが呼ばれる
      resolve("wait: " + time);
    }, time);
  });
}

// Promiseの実行
// (d3)thenで次に実行する処理を登録
wait(1000).then(value => {
  // (d4)1000ミリ秒後に実行される
  console.log(value); // "wait: 1000"
}).then(value => {
  // (d5)上記(d4)のあとすぐ非同期で呼ばれる
  // valueは引き継がれずundefinedになる
  console.log(value); // undefined
});
