// ●リスト7::Promise.allを使ったHTTP GETリクエストを送る関数
Promise.all([
  getUrl("/foo"), getUrl("/bar")
]).then(res => {
  // "/foo"のレスポンス
  console.log(res[0]);
  // "/bar"のレスポンス
  console.log(res[1]);
}).catch(e => {
  // どちらかでエラーが発生したら呼ばれる
  console.error(e);
});

function getUrl(url) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = () => {
      if (xhr.status === 200) {
        resolve(xhr.statusText);
      } else {
        // (d1)エラーの場合rejectを呼ぶ
        reject(new Error(xhr.statusText));
      }
    };
    xhr.onerror = () => {
      // (d2)エラーの場合rejectを呼ぶ
      reject(new Error(xhr.statusText));
    };
    xhr.send();
  });
}
